{
  A small simple test program demonstrating loading of a JOB file and
  displaying it with Borland's BGI interface. Works with BP 7.0.

    John Christian Lonningdal
}

Uses Graph,Crt,Dos;

VAR
 Driver,Mode : Integer;
 Key         : Char;
 JobeFile    : File;
 Buffer      : Pointer;
 Size        : LongInt;
 Pal         : Pointer;

{-------------------------------------------------------------------------}
Function LoadPal(Loadpalette : String) : Pointer;
VAR
 Diskdata        : FILE;
 Ptr             : Pointer;

 BEGIN
  GetMem(Ptr,768);
  ASSIGN (DiskData,Loadpalette);
  RESET (DiskData,1);
  BlockRead(DiskData,Ptr^,768);
  CLOSE (DiskData);
  LoadPal:=Ptr;
 END;

{-------------------------------------------------------------------------}
Procedure UsePalette(P : Pointer);
VAR
  Regs : Registers;

 BEGIN
  with Regs do
  begin
    AH := $10;
    AL := $12;
    BX := 0;
    CX := 256;
    ES := Seg(P^);
    DX := Ofs(P^);
  end;
  Intr($10, Regs);
 END;

BEGIN

  { Change driver to SVGAS3 if you have an S3 card }
  Driver := InstallUserDriver('SVGA256', nil);
  Mode := 0;

  InitGraph(Driver, Mode, '');
  if GraphResult < 0 then
   BEGIN
    Writeln('ERROR: Graphics driver not installed!');
    Halt(1);
   END;

  Pal:=LoadPal('DEFAULT.SVP');
  UsePalette(Pal);
  Assign(JobeFile,'HEAD.JOB');
  Reset(JobeFile,1);

  Size := FileSize(JobeFile);
  GetMem(Buffer,Size);
  BlockRead(JobeFile,Buffer^,Size);
  Close(JobeFile);

  ClearDevice;

  PutImage(100,50,Buffer^,NormalPut);

  Key:=Readkey;
  CloseGraph;

END.